#include <stdint.h>

volatile int16_t sample_val = 0;
volatile int16_t cloud_val = 0;
volatile int32_t filt;
volatile unsigned char sampled;

void init_machine() {
  
  DDRC |= (1 << DDC6); //d5
  DDRB |= (1 << DDB5); //d9
  DDRD |= (1 << DDD3); //d1

  PORTB &= ~(1 << PORTB5);
  PORTC &= ~(1 << PORTC6);
  PORTD &= ~(1 << PORTD3);

  DDRF &= ~(1 << DDF7); //a0
  //DDRF &= ~(1 << DDF6); //a1

  TCCR1A  = 0<<WGM11 | 0<<WGM10;
  TCCR1B  = 0<< WGM13 | 1<<WGM12 | 0<<CS12 | 1<<CS11 | 0<<CS10; 
  TIMSK1  = 1<<OCIE1A;
  OCR1A = 255;

}

void setup() {
	init_machine(); 

	Serial.begin(9600);
  	Serial.flush();
}

void loop() {

sample_val = analogRead(0);

      if (sampled) {
           cloud_val = low_pass(sample_val);
           sampled = 0;
     }

	
	if (cloud_val < 60) {
		output(0, 0, 0);
	} else if ( (cloud_val >= 90) && (cloud_val < 160) ) { //1.0 -- 20% -- 205
		output(1, 0, 0); //fluid 0
	} else if ( (cloud_val >= 190) && (cloud_val < 300) ) { //1.5 -- 30% -- 307
		output(0, 1, 0); //fluid 1
	} else if ( (cloud_val >= 350) && (cloud_val < 405) ) { //2.0 -- 40% -- 410
		output(1, 1, 0); //fluid 2 
	} else if ( (cloud_val >= 420 ) && (cloud_val < 475) ) { //2.5 -- 50% -- 512
		output(0, 0, 1); //fluid 3
	} else if ( (cloud_val >= 485) && (cloud_val < 590) ) { //3.0 -- 60% -- 614
		output(1, 0, 1); //fluid 4
	} else if ( (cloud_val >= 615) && (cloud_val < 700) ) { //3.5 -- 70% -- 717
		output(0, 1, 1); //fluid 5
	} else if ( (cloud_val >= 800) ) {			//4.0 -- 80% -- 819
		output(1, 1, 1); //drink done
	} 

	Serial.print(cloud_val);
	Serial.print("\n");

      //analogWrite(5, (uint16_t)cloud_val);
      //analogWrite(9, sample_val);

}

void output(char d1, char d5, char d9) {
	
	if (d1 == 0) {
		PORTD &= ~(1 << PORTD3);
	} else {
	       PORTD |= (1 << PORTD3);
	}

        if (d5 == 0) {
		PORTC &= ~(1 << PORTC6);
	} else {
		PORTC |= (1 << PORTC6);
	}

	if (d9 == 0) {
		PORTB &= ~(1 << PORTB5);
	} else {
		PORTB |= (1 << PORTB5);
	}		
}

int32_t low_pass(int32_t input)
{
	filt = filt + (((input - filt) >> 7) * 64);
	return filt;
}

ISR(TIMER1_COMPA_vect) {
	sample_val = analogRead(0);
        sampled = 1;
}
